﻿/*
 * Keyb_4x4.c
 *
 * Created: 9/11/2015 1:15:11 am
 *  Author: Dimitrios Porlidas
 */ 

#include "LCD_2x16.h"

#define keyport PORTB
#define keyreg PINB

unsigned char ln1;
unsigned char line;
unsigned char data;
unsigned char entry;

void Keyb (void)											//Keyboard rutine
{
	line = 1;
	for (ln1 = 0; ln1 < 4; ln1++)
	{
		keyport = ~line;
		line = line << 1;
		while (keyreg < 0b11101111)
		{
			_delay_ms (5);
			switch (keyreg)
			{
				case 0b11101110:							//Button 1 pressed
				data = '1';
				entry = 1;
				while (keyreg == 0b11101110);					//Wait if button is still pressed
				break;

				case 0b11101101:							//Button 4 pressed
				data = '4';
				entry = 1;
				while (keyreg == 0b11101101);					//Wait if button is still pressed
				break;

				case 0b11101011:							//Button 7 pressed
				data = '7';
				entry = 1;
				while (keyreg == 0b11101011);					//Wait if button is still pressed
				break;

				case 0b11100111:							//Button * pressed
				data = '*';
				entry = 1;
				while (keyreg == 0b11100111);					//Wait if button is still pressed
				break;

				case 0b11011110:							//Button 2 pressed
				data = '2';
				entry = 1;
				while (keyreg == 0b11011110);					//Wait if button is still pressed
				break;

				case 0b11011101:							//Button 5 pressed
				data = '5';
				entry = 1;
				while (keyreg == 0b11011101);					//Wait if button is still pressed
				break;

				case 0b11011011:							//Button 8 pressed
				data = '8';
				entry = 1;
				while (keyreg == 0b11011011);					//Wait if button is still pressed
				break;

				case 0b11010111:							//Button 0 pressed
				data = '0';
				entry = 1;
				while (keyreg == 0b11010111);					//Wait if button is still pressed
				break;

				case 0b10111110:							//Button 3 pressed
				data = '3';
				entry = 1;
				while (keyreg == 0b10111110);					//Wait if button is still pressed
				break;

				case 0b10111101:							//Button 6 pressed
				data = '6';
				entry = 1;
				while (keyreg == 0b10111101);					//Wait if button is still pressed
				break;

				case 0b10111011:							//Button 9 pressed
				data = '9';
				entry = 1;
				while (keyreg == 0b10111011);					//Wait if button is still pressed
				break;

				case 0b10110111:							//Button # pressed
				data = '#';
				entry = 1;
				while (keyreg == 0b10110111);					//Wait if button is still pressed
				break;

				case 0b01111110:							//Button A pressed
				data = 'A';
				entry = 1;
				while (keyreg == 0b01111110);					//Wait if button is still pressed
				break;

				case 0b01111101:							//Button B pressed
				data = 'B';
				entry = 1;
				while (keyreg == 0b01111101);					//Wait if button is still pressed
				break;

				case 0b01111011:							//Button C pressed
				data = 'C';
				entry = 1;
				while (keyreg == 0b01111011);					//Wait if button is still pressed
				break;

				case 0b01110111:							//Button D pressed
				data = 'D';
				entry = 1;
				while (keyreg == 0b01110111);					//Wait if button is still pressed
				break;
			}
		}
	}
}